-- -----------------------------------------------------------------------------

local ADDON_NAME, ns = ...
local WOEZ_D,WOEZ_O,WOEZ_F = ns.datas,ns.functions,ns.frames

-- -----------------------------------------------------------------------------

local Options = CreateFrame("Frame", "WOEZOptions", InterfaceOptionsFramePanelContainer)
      Options.name = "WOEZ Calendar Invit" 
      Options:Hide()
InterfaceOptions_AddCategory(Options)

-- -----------------------------------------------------------------------------
-- 
-- -----------------------------------------------------------------------------

Options:SetScript("OnShow", function(self)
    WOEZ_O:DEBUG('OPTIONS','','OnShow')
    WOEZ_O:GET_GUILD() 

    local Title = self:CreateFontString("WOEZ_OPT_Title", "ARTWORK", "GameFontNormalLarge")
          Title:SetPoint("TOPLEFT", 16, -16)
          Title:SetText(self.name)

    local Version = WOEZ_O:FONT("WOEZ_OPT_Version",self,"TOPLEFT", Title    , "BOTTOMLEFT", 0, -8,          nil,nil,"GameFontHighlightSmall","LEFT")
          Version:SetText("v"..WO_ez_DB.version)


    function self:refresh()
        WOEZ_O:DEBUG('OPTIONS','','Refresh')
        local HShowRank = -40

        
        if WOEZ_D.InGuild then
            
            -- get list guild rank
            local infos = {}            
            for i=2, GuildControlGetNumRanks() do
                local Nameg = GuildControlGetRankName(i)
                if Nameg then infos[i] = Nameg end
            end

            local ShowGMrank = WOEZ_O:FONT("WOEZ_OPT_GM",self,  "TOPLEFT", Version, "BOTTOMLEFT", 23, HShowRank,   nil,nil,"GameFontNormal","LEFT")
                  ShowGMrank:SetText("Show GuildMaster in rank :")

            HShowRank = HShowRank -16

            local infos = {}            
            for i=2, GuildControlGetNumRanks() do
                local Nameg = GuildControlGetRankName(i)
                if Nameg then infos[i] = Nameg end
            end
            local obj = "WOEZ_OPT_GMR"
            local GMRankDropdown = _G[obj] or CreateFrame("Frame",obj, self, "UIDropDownMenuTemplate")
                  GMRankDropdown:SetPoint("TOPLEFT", Version, "BOTTOMLEFT", 4, HShowRank)
                  GMRankDropdown.initialize = function()
                        info = {}
                        for u, grank in pairs(infos) do
                            info.text = grank
                            info.value = u
                            info.func = function(self)
                                WO_ez_DBC.guildrankGM = self.value
                                info.checked = self.value == self.text 
                                UIDropDownMenu_SetText(GMRankDropdown, self:GetText()) 
                                WOEZ_O:SET_ROSTER()
                            end
                            info.checked = u == WO_ez_DBC.guildrankGM
                            UIDropDownMenu_AddButton(info)
                        end
                  end
            if infos[WO_ez_DBC.guildrankGM] then UIDropDownMenu_SetText(GMRankDropdown, infos[WO_ez_DBC.guildrankGM]) end
            GMRankDropdown:Show()

            HShowRank = HShowRank-70

        end

        -- ------------------------------------------------------- ON enable_ilevl
        WO_ez_DB.enable_notes = WO_ez_DBC.enable_notes or true
        local enableNO = WOEZ_O:FRAM("WOEZ_OPT_NO","CheckButton",self,"ChatConfigCheckButtonTemplate",
                                 "TOPLEFT", Version  , "BOTTOMLEFT", 22, HShowRank,nil,WOEZ_D.fonts.TXT_14,WOEZ_D.fonts.TXT_14)

              enableNO:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.enable_notes = true else WO_ez_DBC.enable_notes = false end WOEZ_O:SET_ROSTER() end)  
              if WO_ez_DBC.enable_notes then enableNO:SetChecked(true) end

        local enableNO_txt = WOEZ_O:FONT("WOEZ_OPT_NO_txt",enableNO,"LEFT",enableNO,"RIGHT",WOEZ_D.sizes.MMARGS,0, nil,nil,WOEZ_D.fonts.TTL_F ,"LEFT")
              enableNO_txt:SetText("Display note column")   
              enableNO_txt:SetTextColor(1,1,1,1) 

        HShowRank = HShowRank-40

        -- ------------------------------------------------------- ON enable_ilevl
        WO_ez_DB.enable_ilevl = WO_ez_DBC.enable_ilevl or true
        local enableIL = WOEZ_O:FRAM("WOEZ_OPT_IL","CheckButton",self,"ChatConfigCheckButtonTemplate",
                                 "TOPLEFT", Version  , "BOTTOMLEFT", 22, HShowRank,nil,WOEZ_D.fonts.TXT_14,WOEZ_D.fonts.TXT_14)

              enableIL:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.enable_ilevl = true else WO_ez_DBC.enable_ilevl = false end WOEZ_O:SET_ROSTER() end)  
              if WO_ez_DBC.enable_ilevl then enableIL:SetChecked(true) end

        local enableIL_txt = WOEZ_O:FONT("WOEZ_OPT_IL_txt",enableIL,"LEFT",enableIL,"RIGHT",WOEZ_D.sizes.MMARGS,0, nil,nil,WOEZ_D.fonts.TTL_F ,"LEFT")
              enableIL_txt:SetText("Display ilevel column")   
              enableIL_txt:SetTextColor(1,1,1,1) 

        HShowRank = HShowRank-40

        -- ------------------------------------------------------- ON enable_ilevf
        WO_ez_DB.enable_ilevf = WO_ez_DBC.enable_ilevf or true
        local enableIF = WOEZ_O:FRAM("WOEZ_OPT_IF","CheckButton",self,"ChatConfigCheckButtonTemplate",
                                 "TOPLEFT", Version  , "BOTTOMLEFT", 22, HShowRank,nil,WOEZ_D.fonts.TXT_14,WOEZ_D.fonts.TXT_14)

              enableIF:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.enable_ilevf = true else WO_ez_DBC.enable_ilevf = false end WOEZ_O:SET_ROSTER() end)  
              if WO_ez_DBC.enable_ilevf then enableIF:SetChecked(true) end

        local enableIF_txt = WOEZ_O:FONT("WOEZ_OPT_IF_txt",enableIF,"LEFT",enableIF,"RIGHT",WOEZ_D.sizes.MMARGS,0, nil,nil,WOEZ_D.fonts.TTL_F ,"LEFT")
              enableIF_txt:SetText("Enable fading lower ilevel")   
              enableIF_txt:SetTextColor(1,1,1,1) 

        HShowRank = HShowRank-40

        -- ------------------------------------------------------- ON enable_icons
        WO_ez_DB.enable_icons = WO_ez_DBC.enable_icons or true
        local enableIC = WOEZ_O:FRAM("WOEZ_OPT_IC","CheckButton",self,"ChatConfigCheckButtonTemplate",
                                 "TOPLEFT", Version  , "BOTTOMLEFT", 22, HShowRank,nil,WOEZ_D.fonts.TXT_14,WOEZ_D.fonts.TXT_14)

              enableIC:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.enable_icons = true else WO_ez_DBC.enable_icons = false end WOEZ_O:SET_ROSTER() end)  
              if WO_ez_DBC.enable_icons then enableIC:SetChecked(true) end

        local enableIC_txt = WOEZ_O:FONT("WOEZ_OPT_IC_txt",enableIC,"LEFT",enableIC,"RIGHT",WOEZ_D.sizes.MMARGS,0, nil,nil,WOEZ_D.fonts.TTL_F ,"LEFT")
              enableIC_txt:SetText("Enable roles icons")   
              enableIC_txt:SetTextColor(1,1,1,1) 

        local enableIC_inf = WOEZ_O:FONT("WOEZ_OPT_IC_inf",enableIC,"LEFT",enableIC,"RIGHT",WOEZ_D.sizes.MMARGS,-20, nil,nil,"GameFontHighlightSmall","LEFT")
              enableIC_inf:SetText("Require 'TANK', 'HEAL', 'DPS', 'MELEE' or 'RANGE' to be written in note...")   
              enableIC_inf:SetTextColor(1,1,1,.4) 

        HShowRank = HShowRank-70

        -- ------------------------------------------------------- ON pvate_list

--        WO_ez_DB.pvate_list = WO_ez_DBC.pvate_list or true
--        local enablePV = WOEZ_O:FRAM("WOEZ_OPT_PV","CheckButton",self,"ChatConfigCheckButtonTemplate",
--                                 "TOPLEFT", Version  , "BOTTOMLEFT", 22, HShowRank,nil,WOEZ_D.fonts.TXT_14,WOEZ_D.fonts.TXT_14)
--
--        local enablePV_txt = WOEZ_O:FONT("WOEZ_OPT_PV_txt",enablePV,"LEFT",enablePV,"RIGHT",WOEZ_D.sizes.MMARGS,0, nil,nil,WOEZ_D.fonts.TTL_F ,"LEFT")
--              enablePV_txt:SetText("Enable private list")   
--              enablePV_txt:SetTextColor(1,1,1,1) 
--
--        local obj = "WOEZ_OPT_namePV"
--        local namePV = _G[obj] or CreateFrame("EditBox",enablePV, self, "InputBoxTemplate")
--              namePV:SetPoint("TOPLEFT", enablePV, 9, -32)
--              namePV:SetPoint("BOTTOMRIGHT", enablePV, "RIGHT", 222,-36)
--
--              namePV:SetScript("OnEnterPressed",    function(self) WO_ez_DBC.pvate_name = self:GetText() WOEZ_O:SET_ROSTER() end)
--              namePV:SetScript("OnEscapePressed",   function(self) WO_ez_DBC.pvate_name = self:GetText() WOEZ_O:SET_ROSTER() end)
--
--              namePV:SetText(WO_ez_DBC.pvate_name) 
--              namePV:Show()
--
--        enablePV:SetScript("OnClick", function(self, button) 
--            if self:GetChecked() then 
--                WO_ez_DBC.pvate_list = true 
--                namePV:SetEnabled(true)   namePV:Show() 
--            else 
--                WO_ez_DBC.pvate_list = false 
--                namePV:SetEnabled(false)  namePV:Hide() 
--            end WOEZ_O:SET_ROSTER() end)  
--              
--        if WO_ez_DBC.pvate_list then enablePV:SetChecked(true)  namePV:SetEnabled(true)  namePV:Show() 
--                                else enablePV:SetChecked(false) namePV:SetEnabled(false) namePV:Hide()  end

    end
    self:refresh()
    self:SetScript("OnShow", nil)
end)


-- -----------------------------------------------------------------------------
-- options options
-- -----------------------------------------------------------------------------

SLASH_WOEZ1 = "/woez"
SlashCmdList.WOEZ = function()
	InterfaceOptionsFrame_OpenToCategory(Options)
    InterfaceOptionsFrame_OpenToCategory(Options)
end

-- -----------------------------------------------------------------------------